Index: trunk/src/lib/graphics/importer/height_map.cc
===================================================================
--- trunk/src/lib/graphics/importer/height_map.cc	(revision 7499)
+++ trunk/src/lib/graphics/importer/height_map.cc	(revision 7500)
@@ -141,5 +141,5 @@
                      normalVectorField[i % this->heightMapReference->heightMap->h][w % this->heightMapReference->heightMap->w].z,
                      normalVectorField[i % this->heightMapReference->heightMap->h][w % this->heightMapReference->heightMap->w].x);
-    model->addTexCoor((float)(yOffset-sampleRate) /(texRate), (float)(i %this->heightMapReference->heightMap->h)/(texRate));
+    model->addTexCoor((float)(yOffset-sampleRate) /(HM_TEX_RATE), (float)(i %this->heightMapReference->heightMap->h)/(HM_TEX_RATE));
     model->addColor(r/255.0f, g/255.0f, b/255.0f);
 
@@ -170,5 +170,5 @@
                        normalVectorField[i % this->heightMapReference->heightMap->h][j % this->heightMapReference->heightMap->w].z,
                        normalVectorField[i % this->heightMapReference->heightMap->h][j % this->heightMapReference->heightMap->w].x);
-      model->addTexCoor((float)(j) /(texRate), (float)(i %this->heightMapReference->heightMap->h)/(texRate));
+      model->addTexCoor((float)(j) /(HM_TEX_RATE), (float)(i %this->heightMapReference->heightMap->h)/(HM_TEX_RATE));
       model->addColor(r/255.0f, g/255.0f, b/255.0f);
       //PRINTF(0)("TexCoord:  %f %f \n",(float)j / 100.0, (float)(i %this->heightMapReference->h)/100.0);
@@ -180,5 +180,5 @@
                      normalVectorField[i % this->heightMapReference->heightMap->h][w % this->heightMapReference->heightMap->w].z,
                      normalVectorField[i% this->heightMapReference->heightMap->h][w % this->heightMapReference->heightMap->w].x);
-    model->addTexCoor((float)(j2+sampleRate) /(texRate), (float)(i %this->heightMapReference->heightMap->h)/(texRate));
+    model->addTexCoor((float)(j2+sampleRate) /(HM_TEX_RATE), (float)(i %this->heightMapReference->heightMap->h)/(HM_TEX_RATE));
     model->addColor(r/255.0f, g/255.0f, b/255.0f);
   }
@@ -217,5 +217,5 @@
                      normalVectorField[i % this->heightMapReference->heightMap->h][j % this->heightMapReference->heightMap->w].z,
                      normalVectorField[i % this->heightMapReference->heightMap->h][j % this->heightMapReference->heightMap->w].x);
-    model->addTexCoor((float)j /(texRate), (float)((i - sampleRate) %this->heightMapReference->heightMap->h)/(texRate));
+    model->addTexCoor((float)j /(HM_TEX_RATE), (float)((i - sampleRate) %this->heightMapReference->heightMap->h)/(HM_TEX_RATE));
     model->addColor(r/255.0f, g/255.0f, b/255.0f);
   }
@@ -241,5 +241,5 @@
                      normalVectorField[i % this->heightMapReference->heightMap->h][j% this->heightMapReference->heightMap->w].z,
                      normalVectorField[i%this->heightMapReference->heightMap->h][j%this->heightMapReference->heightMap->w].x);
-    model->addTexCoor((float)j /(texRate), (float)(i %this->heightMapReference->heightMap->h)/(texRate));
+    model->addTexCoor((float)j /(HM_TEX_RATE), (float)(i %this->heightMapReference->heightMap->h)/(HM_TEX_RATE));
     model->addColor(r/255.0f, g/255.0f, b/255.0f);
   }
@@ -263,5 +263,5 @@
                      normalVectorField[i%this->heightMapReference->heightMap->h][j%this->heightMapReference->heightMap->w].z,
                      normalVectorField[i%this->heightMapReference->heightMap->h][j%this->heightMapReference->heightMap->w].x);
-    model->addTexCoor((float)j /(texRate), (float)((i+ sampleRate) %this->heightMapReference->heightMap->h)/(texRate));
+    model->addTexCoor((float)j /(HM_TEX_RATE), (float)((i+ sampleRate) %this->heightMapReference->heightMap->h)/(HM_TEX_RATE));
     model->addColor(r/255.0f, g/255.0f, b/255.0f);
   }
@@ -286,5 +286,5 @@
                      normalVectorField[i%this->heightMapReference->heightMap->h][j%this->heightMapReference->heightMap->w].z,
                      normalVectorField[i%this->heightMapReference->heightMap->h][j%this->heightMapReference->heightMap->w].x);
-    model->addTexCoor((float)j /(texRate), (float)(i %this->heightMapReference->heightMap->h)/(texRate));
+    model->addTexCoor((float)j /(HM_TEX_RATE), (float)(i %this->heightMapReference->heightMap->h)/(HM_TEX_RATE));
     model->addColor(r/255.0f, g/255.0f, b/255.0f);
   }
@@ -385,12 +385,12 @@
   delete colorMap;
 
-  for(int i=0;i <    heightMap->h/tileSize ; i++)
-  {
-    for(int j = 0; j < heightMap->w/ tileSize; j++)
+  for(int i=0;i <    heightMap->h/HM_TILE_SIZE ; i++)
+  {
+    for(int j = 0; j < heightMap->w/ HM_TILE_SIZE; j++)
     {
       delete tiles [i][j];
     }
   }
-  for(int i=0;i <    heightMap->h/tileSize ; i++)
+  for(int i=0;i <    heightMap->h/HM_TILE_SIZE ; i++)
     delete[] tiles[i];
   delete[] tiles;
@@ -444,13 +444,13 @@
 {
   // create a dynamicly sized 2D-array for tiles
-  this->tiles =  new Tile**[this->heightMap->h / this->tileSize];
-
-  for( int i = 0;i < heightMap->h / tileSize; i++)
-    this->tiles [i]= new Tile*[this->heightMap->w / this->tileSize];
+  this->tiles =  new Tile**[this->heightMap->h / HM_TILE_SIZE];
+
+  for( int i = 0;i < heightMap->h / HM_TILE_SIZE; i++)
+    this->tiles [i]= new Tile*[this->heightMap->w / HM_TILE_SIZE];
 
   // setup arrays
-  for( int i = 0; i < this->heightMap->h / this->tileSize; i++)  {
-    for( int j = 0; j < this->heightMap->w / this->tileSize; j++) {
-      this->tiles[i][j] = new Tile( i * tileSize ,  j * tileSize , (i+1) * tileSize, (j+1) * tileSize , this);
+  for( int i = 0; i < this->heightMap->h / HM_TILE_SIZE; i++)  {
+    for( int j = 0; j < this->heightMap->w / HM_TILE_SIZE; j++) {
+      this->tiles[i][j] = new Tile( i * HM_TILE_SIZE ,  j * HM_TILE_SIZE , (i+1) * HM_TILE_SIZE, (j+1) * HM_TILE_SIZE , this);
     }
   }
@@ -467,7 +467,7 @@
 
   int i_min = 0;
-  int i_max = (heightMap->h )/ tileSize;
+  int i_max = (heightMap->h )/ HM_TILE_SIZE;
   int j_min = 0;
-  int j_max= (heightMap->w  ) / tileSize;
+  int j_max= (heightMap->w  ) / HM_TILE_SIZE;
 
 
Index: trunk/src/lib/graphics/importer/height_map.h
===================================================================
--- trunk/src/lib/graphics/importer/height_map.h	(revision 7499)
+++ trunk/src/lib/graphics/importer/height_map.h	(revision 7500)
@@ -20,7 +20,6 @@
 
 
-#define texRate      32
-#define texRatef     4.0f
-#define tileSize     64
+#define HM_TEX_RATE      32
+#define HM_TILE_SIZE     64
 
 //!< define the LOD level distances. later this could be dynamicaly adjusted