Index: branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc~
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc~	(revision 7505)
+++ 	(revision )
@@ -1,115 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-### File Specific:
-   main-programmer: hdavid, amaechler
-*/
-
-#include "volfog_effect.h"
-
-#include "util/loading/load_param.h"
-#include "util/loading/factory.h"
-
-#include "glincl.h"
-
-#include "shell_command.h"
-/*SHELL_COMMAND(activateVolFog, VolFogEffect, VolFogEffect::activate)
-  ->setAlias("aVolFog");
-SHELL_COMMAND(deactivateVolFog, VolFogEffect, VolFogEffect::deactivate)
-  ->setAlias("dVolFog");*/
-
-using namespace std;
-
-CREATE_FACTORY(VolFogEffect, CL_VOLFOG_EFFECT);
-
-VolFogEffect::VolFogEffect(const TiXmlElement* root)
-{
-  this->setClassID(CL_VOLFOG_EFFECT, "VolFogEffect");
-
-  this->volfogMode = GL_LINEAR;
-  this->volfogDensity = 0.001f;
-  this->volfogStart = 10.0f;
-  this->volfogEnd = 1000.0f;
-
-  if (root != NULL)
-    this->loadParams(root);
-
-  this->activate();
-}
-
-
-
-VolFogEffect::~VolFogEffect()
-{
-  this->deactivate();
-}
-
-
-void VolFogEffect::loadParams(const TiXmlElement* root)
-{
-  WeatherEffect::loadParams(root);
-
-  LoadParam(root, "volfog-mode", this, VolFogEffect, setVolFogMode);
-  LoadParam(root, "volfog-density", this, VolFogEffect, setVolFogDensity);
-  LoadParam(root, "volfog-color", this, VolFogEffect, setVolFogColor);
-
-
-}
-
-bool VolFogEffect::init()
-{}
-
-
-
-bool VolFogEffect::activate()
-{
-  PRINTF(0)( "Enabling VolFog Effect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->volfogMode, this->volfogDensity,
-             this->volfogStart, this->volfogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
-
-  glEnable(GL_FOG);
-  {
-    //GLfloat volfogColor[4] = {0.7, 0.6, 0.6, 1.0};
-    GLfloat volfogColor[4] = { colorVector.x, colorVector.y, colorVector.z, 1.0};
-
-    glVolFogi(GL_FOG_MODE, this->volfogMode);
-    glVolFogfv(GL_FOG_COLOR, volfogColor);
-    glVolFogf(GL_FOG_DENSITY, this->volfogDensity);
-    glHint(GL_FOG_HINT, GL_DONT_CARE);
-    glVolFogf(GL_FOG_START, this->volfogStart);
-    glVolFogf(GL_FOG_END, this->volfogEnd);
-
-    //glVolFogi(GL_VOLFOG_COORDINATE_SOURCE, GL_VOLFOG_COORDINATE);
-  }
-  glClearColor(0.5, 0.5, 0.5, 1.0);
-}
-
-
-
-bool VolFogEffect::deactivate()
-{
-  PRINTF(0)("Deactivating VolFog Effect");
-	glDisable(GL_FOG);
-}
-
-
-
-GLint VolFogEffect::stringToVolFogMode(const std::string& mode)
-{
-  if(mode == "GL_LINEAR")
-    return GL_LINEAR;
-  else if(mode == "GL_EXP")
-    return GL_EXP;
-  else if(mode == "GL_EXP2" )
-    return GL_EXP2;
-  else
-    return -1;
-}
-
-
Index: branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h~
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h~	(revision 7505)
+++ 	(revision )
@@ -1,44 +1,0 @@
-/**
- * @file volfog_effect.h
- */
-
-#ifndef _VOLFOG_EFFECT
-#define _VOLFOG_EFFECT
-
-#include "vector.h"
-
-#include "weather_effect.h"
-
-class VolFogEffect : public WeatherEffect
-{
-  public:
-    VolFogEffect(const TiXmlElement* root = NULL);
-    virtual ~VolFogEffect();
-
-    virtual void loadParams(const TiXmlElement* root);
-
-    virtual bool init();
-
-    virtual bool activate();
-    virtual bool deactivate();
-
-    inline void setVolFogMode(const std::string& mode) { this->volfogMode = this->stringToVolFogMode(mode); }
-    inline void setVolFogDensity(float density) { this->volfogDensity = density; }
-    inline void setVolFogRange(float start, float end) { this->volfogStart = start; this->volfogEnd = end; }
-    inline void setVolFogColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
-
-
-  private:
-    GLint stringToVolFogMode(const std::string& mode);
-
-
-  private:
-    GLint                   volfogMode;
-    GLfloat                 volfogDensity;
-    GLfloat                 volfogStart;
-    GLfloat                 fogEnd;
-    Vector                  colorVector;
-};
-
-
-#endif  /* _VOLFOG_EFFECT */