Index: /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 7522)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 7523)
@@ -20,6 +20,6 @@
 #include "glincl.h"
 
-#include "shell_command.h"
-/*SHELL_COMMAND(activateFog, FogEffect, FogEffect::activate)
+/*#include "shell_command.h"
+SHELL_COMMAND(activateFog, FogEffect, FogEffect::activate)
   ->setAlias("aFog");
 SHELL_COMMAND(deactivateFog, FogEffect, FogEffect::deactivate)
@@ -71,6 +71,5 @@
 bool FogEffect::activate()
 {
-  PRINTF(0)( "Enabling Fog Effect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->fogMode, this->fogDensity,
-             this->fogStart, this->fogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
+  PRINTF(0)( "Enabling Fog Effect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->fogMode, this->fogDensity, this->fogStart, this->fogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
 
   glEnable(GL_FOG);
Index: /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 7522)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 7523)
@@ -32,10 +32,10 @@
 
 world_vector vertices[NUM_PANELS*4] = {
-	{-5.0, -10.0, 0.0},{5.0, -10.0, 0.0},{5.0, 0.0, 0.0},{-5.0, 0.0, 0.0},
-	{-5.0, -10.0, 10.0},{-5.0, -10.0, 0.0},{-5.0, 0.0, 0.0},{-5.0, 0.0, 10.0},
-	{-5.0, -10.0, 20.0},{-5.0, -10.0, 10.0},{-5.0, 0.0, 10.0},{-5.0, 0.0, 20.0},
-	{5.0, -10.0, 0.0},{5.0, -10.0, 10.0},{5.0, 0.0, 10.0},{5.0, 0.0, 0.0},
-	{5.0, -10.0, 10.0},{5.0, -10.0, 20.0},{5.0, 0.0, 20.0},{5.0, 0.0, 10.0},
-	{-5.0, -10.0, 10.0},{5.0, -10.0, 10.0},{5.0, -10.0, 0.0},{-5.0, -10.0, 0.0}
+	{-50.0, -60.0, 0.0},{50.0, -60.0, 0.0},{50.0, 0.0, 0.0},{-50.0, 0.0, 0.0},
+	{-50.0, -60.0, 60.0},{-50.0, -60.0, 0.0},{-50.0, 0.0, 0.0},{-50.0, 0.0, 60.0},
+	{-50.0, -60.0, 20.0},{-50.0, -60.0, 60.0},{-50.0, 0.0, 60.0},{-50.0, 0.0, 20.0},
+	{50.0, -60.0, 0.0},{50.0, -60.0, 60.0},{50.0, 0.0, 60.0},{50.0, 0.0, 0.0},
+	{50.0, -60.0, 60.0},{50.0, -60.0, 20.0},{50.0, 0.0, 20.0},{50.0, 0.0, 60.0},
+	{-50.0, -60.0, 60.0},{50.0, -60.0, 60.0},{50.0, -60.0, 0.0},{-50.0, -60.0, 0.0}
 };
 
@@ -65,15 +65,12 @@
   WeatherEffect::loadParams(root);
 
-  LoadParam(root, "test", this, VolFogEffect, test);
+  LoadParam(root, "fog-altitude", this, VolFogEffect, setFogAltitude);
+  LoadParam(root, "fog-color", this, VolFogEffect, startFogColor);
 }
 
-void VolFogEffect::test(int t)
-{
-PRINTF(0)("test\n\n");
-}
 
 bool VolFogEffect::init()
 {
-
+  PRINTF(0)("Initalize VolFogEffect\n");
 };
 
@@ -82,5 +79,6 @@
 bool VolFogEffect::activate()
 {
-  PRINTF(0)("Activate VolFogEffect\n");
+  PRINTF(0)( "Enabling Volumetric Fog Effect, altitude: %i, color %f, %f, %f\n", this->fogAltitude, this->colorVector.x, this->colorVector.y, this->colorVector.z);
+
 }
 
@@ -91,5 +89,5 @@
 
 
-void setFogColor(int v)
+void VolFogEffect::setFogColor(int v)
 {
 	float z;	/* distance of vertex from edge of fog volume */
@@ -97,9 +95,9 @@
 
 	z = 0.0 - vertices[v].y;
-	f = (10.0 - z) / (10.0 - 0.0);	/* linear fog: f = (end - z)/(end - start) */
-	glColor4f(0.6, 0.2, 0.0, f);
+	f = (60.0 - z) / (60.0 - 0.0);	/* linear fog: f = (end - z)/(end - start) */
+	glColor4f(this->colorVector.x, this->colorVector.y, this->colorVector.z, f);
 }
 
-	int v;		/* store of next vertex ref */
+// int v;		/* store of next vertex ref */
 
 /**
@@ -108,5 +106,5 @@
 void VolFogEffect::draw() const
 {
-	// int v;		/* store of next vertex ref */
+	int v;		/* store of next vertex ref */
 	int ref;
 
@@ -118,6 +116,4 @@
 		glDepthMask(GL_FALSE);
 	
-		v = ref * 4;
-
 		/* restore z buffer writes, set blend params & disable texturing */
 
@@ -131,11 +127,11 @@
 		v = ref * 4;
 		glBegin(GL_QUADS);
-		setFogColor(v);
+		//this->setFogColor(v);
 		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z); v++;
-		setFogColor(v);
+		//this->setFogColor(v);
 		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z); v++;
-		setFogColor(v);
+		//this->setFogColor(v);
 		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z); v++;
-		setFogColor(v);
+		//this->setFogColor(v);
 		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z);
 		glEnd();
Index: /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h	(revision 7522)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h	(revision 7523)
@@ -23,13 +23,15 @@
     virtual bool deactivate();
 
-    void test(int t);
-
-
     virtual void draw() const;
     virtual void tick(float dt);
 
+    inline void startFogColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
+    inline void setFogAltitude(float altitude) { this->fogAltitude = altitude; }
+
+
   private:
-    void set_fog_colour(int v);
-
+    void setFogColor(int v);
+    GLfloat                 fogAltitude;
+    Vector                  colorVector;
 };
 