Index: /code/branches/ois_update/src/libraries/core/CorePrereqs.h
===================================================================
--- /code/branches/ois_update/src/libraries/core/CorePrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/libraries/core/CorePrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _CorePrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _CoreExport  __attribute__ ((visibility("default")))
+#  define _CorePrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _CoreExport
+#  define _CorePrivate
 #endif
 
Index: /code/branches/ois_update/src/libraries/network/NetworkPrereqs.h
===================================================================
--- /code/branches/ois_update/src/libraries/network/NetworkPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/libraries/network/NetworkPrereqs.h	(revision 7527)
@@ -52,8 +52,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _NetworkPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _NetworkExport  __attribute__ ((visibility("default")))
+#  define _NetworkPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _NetworkExport
+#  define _NetworkPrivate
 #endif
 
Index: /code/branches/ois_update/src/libraries/tools/ToolsPrereqs.h
===================================================================
--- /code/branches/ois_update/src/libraries/tools/ToolsPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/libraries/tools/ToolsPrereqs.h	(revision 7527)
@@ -52,8 +52,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _ToolsPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _ToolsExport  __attribute__ ((visibility("default")))
+#  define _ToolsPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _ToolsExport
+#  define _ToolsPrivate
 #endif
 
Index: /code/branches/ois_update/src/libraries/util/UtilPrereqs.h
===================================================================
--- /code/branches/ois_update/src/libraries/util/UtilPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/libraries/util/UtilPrereqs.h	(revision 7527)
@@ -52,8 +52,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _UtilPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _UtilExport  __attribute__ ((visibility("default")))
+#  define _UtilPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _UtilExport
+#  define _UtilPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/designtools/DesignToolsPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/designtools/DesignToolsPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/designtools/DesignToolsPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _DesignToolsPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _DesignToolsExport  __attribute__ ((visibility("default")))
+#  define _DesignToolsPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _DesignToolsExport
+#  define _DesignToolsPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/notifications/NotificationsPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/notifications/NotificationsPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/notifications/NotificationsPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _NotificationsPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _NotificationsExport  __attribute__ ((visibility("default")))
+#  define _NotificationsPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _NotificationsExport
+#  define _NotificationsPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/objects/ObjectsPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/objects/ObjectsPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/objects/ObjectsPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _ObjectsPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _ObjectsExport  __attribute__ ((visibility("default")))
+#  define _ObjectsPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _ObjectsExport
+#  define _ObjectsPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/overlays/OverlaysPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/overlays/OverlaysPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/overlays/OverlaysPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _OverlaysPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _OverlaysExport  __attribute__ ((visibility("default")))
+#  define _OverlaysPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _OverlaysExport
+#  define _OverlaysPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/pickup/PickupPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/pickup/PickupPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/pickup/PickupPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _PickupPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _PickupExport  __attribute__ ((visibility("default")))
+#  define _PickupPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _PickupExport
+#  define _PickupPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/pong/PongPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/pong/PongPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/pong/PongPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _PongPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _PongExport  __attribute__ ((visibility("default")))
+#  define _PongPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _PongExport
+#  define _PongPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/questsystem/QuestsystemPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/questsystem/QuestsystemPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/questsystem/QuestsystemPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _QuestsystemPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _QuestsystemExport  __attribute__ ((visibility("default")))
+#  define _QuestsystemPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _QuestsystemExport
+#  define _QuestsystemPrivate
 #endif
 
Index: /code/branches/ois_update/src/modules/weapons/WeaponsPrereqs.h
===================================================================
--- /code/branches/ois_update/src/modules/weapons/WeaponsPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/modules/weapons/WeaponsPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _WeaponsPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _WeaponsExport  __attribute__ ((visibility("default")))
+#  define _WeaponsPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _WeaponsExport
+#  define _WeaponsPrivate
 #endif
 
Index: /code/branches/ois_update/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- /code/branches/ois_update/src/orxonox/OrxonoxPrereqs.h	(revision 7526)
+++ /code/branches/ois_update/src/orxonox/OrxonoxPrereqs.h	(revision 7527)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _OrxonoxPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _OrxonoxExport  __attribute__ ((visibility("default")))
+#  define _OrxonoxPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _OrxonoxExport
+#  define _OrxonoxPrivate
 #endif
 