Index: branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 7523)
+++ branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 7530)
@@ -22,5 +22,5 @@
 #include "shell_command.h"
 
-#define NUM_PANELS 6	/* number of panels in scene */
+/*#define NUM_PANELS 6;
 
 typedef struct
@@ -29,5 +29,5 @@
 	float y;
 	float z;
-} world_vector;		/* vertex data */
+} world_vector;
 
 world_vector vertices[NUM_PANELS*4] = {
@@ -38,5 +38,5 @@
 	{50.0, -60.0, 60.0},{50.0, -60.0, 20.0},{50.0, 0.0, 20.0},{50.0, 0.0, 60.0},
 	{-50.0, -60.0, 60.0},{50.0, -60.0, 60.0},{50.0, -60.0, 0.0},{-50.0, -60.0, 0.0}
-};
+};*/
 
 using namespace std;
@@ -65,8 +65,13 @@
   WeatherEffect::loadParams(root);
 
-  LoadParam(root, "fog-altitude", this, VolFogEffect, setFogAltitude);
-  LoadParam(root, "fog-color", this, VolFogEffect, startFogColor);
+  //LoadParam(root, "fog-altitude", this, VolFogEffect, setFogAltitude);
+  //LoadParam(root, "fog-color", this, VolFogEffect, startFogColor);
+  LoadParam(root, "test", this, VolFogEffect, test);
 }
 
+void VolFogEffect::test(int t)
+{
+  PRINTF(0)("Test: %i\n", t);
+}
 
 bool VolFogEffect::init()
@@ -79,6 +84,7 @@
 bool VolFogEffect::activate()
 {
-  PRINTF(0)( "Enabling Volumetric Fog Effect, altitude: %i, color %f, %f, %f\n", this->fogAltitude, this->colorVector.x, this->colorVector.y, this->colorVector.z);
+  //PRINTF(0)( "Enabling Volumetric Fog Effect, altitude: %i, color %f, %f, %f\n", this->fogAltitude, this->colorVector.x, this->colorVector.y, this->colorVector.z);
 
+  PRINTF(0)("Activate VolFogEffect\n");
 }
 
@@ -88,16 +94,15 @@
 }
 
-
+/*
 void VolFogEffect::setFogColor(int v)
 {
-	float z;	/* distance of vertex from edge of fog volume */
-	float f;	/* fog factor */
+	float z;	
+	float f;	
 
 	z = 0.0 - vertices[v].y;
-	f = (60.0 - z) / (60.0 - 0.0);	/* linear fog: f = (end - z)/(end - start) */
+	f = (60.0 - z) / (60.0 - 0.0);	
 	glColor4f(this->colorVector.x, this->colorVector.y, this->colorVector.z, f);
 }
-
-// int v;		/* store of next vertex ref */
+*/
 
 /**
@@ -106,5 +111,6 @@
 void VolFogEffect::draw() const
 {
-	int v;		/* store of next vertex ref */
+
+	/*int v;		// store of next vertex ref
 	int ref;
 
@@ -113,8 +119,8 @@
 	for (ref=0; ref<NUM_PANELS; ref++) {
 
-		/* disable writes to z buffer (if fog area) */
+		// disable writes to z buffer (if fog area) 
 		glDepthMask(GL_FALSE);
 	
-		/* restore z buffer writes, set blend params & disable texturing */
+		// restore z buffer writes, set blend params & disable texturing 
 
 		glDepthMask(GL_TRUE);
@@ -123,5 +129,5 @@
 		glDisable(GL_TEXTURE_2D);
 
-		/* draw the fog panel */
+		// draw the fog panel 
 
 		v = ref * 4;
@@ -137,11 +143,9 @@
 		glEnd();
 
-		/* restore rendering state */
+		// restore rendering state
 
 		glEnable(GL_TEXTURE_2D);
 		glDisable(GL_BLEND);
-	}
-
-	
+	}*/	
 }
 
@@ -153,4 +157,3 @@
 void VolFogEffect::tick(float dt)	
 {
-  PRINTF(0)("TICK VolFogEffect\n");
 }
Index: branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h	(revision 7523)
+++ branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h	(revision 7530)
@@ -26,12 +26,12 @@
     virtual void tick(float dt);
 
-    inline void startFogColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
-    inline void setFogAltitude(float altitude) { this->fogAltitude = altitude; }
-
+    //inline void startFogColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
+    //inline void setFogAltitude(float altitude) { this->fogAltitude = altitude; }
+    void test(int t);
 
   private:
-    void setFogColor(int v);
-    GLfloat                 fogAltitude;
-    Vector                  colorVector;
+    //void setFogColor(int v);
+    //GLfloat                 fogAltitude;
+    //Vector                  colorVector;
 };
 
Index: branches/atmospheric_engine/src/story_entities/game_world.cc
===================================================================
--- branches/atmospheric_engine/src/story_entities/game_world.cc	(revision 7523)
+++ branches/atmospheric_engine/src/story_entities/game_world.cc	(revision 7530)
@@ -42,4 +42,5 @@
 
 #include "graphics_engine.h"
+#include "effects/atmospheric_engine.h"
 #include "event_handler.h"
 #include "sound_engine.h"
@@ -376,4 +377,5 @@
 
     GraphicsEngine::getInstance()->tick(this->dtS);
+    AtmosphericEngine::getInstance()->tick(this->dtS);
 
     if( likely(this->dataTank->gameRule != NULL))
@@ -452,4 +454,6 @@
   GraphicsEngine* engine = GraphicsEngine::getInstance();
 
+  AtmosphericEngine::getInstance()->draw();
+
   // set camera
   this->dataTank->localCamera->apply ();