Index: branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.cc	(revision 7530)
+++ branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.cc	(revision 7532)
@@ -75,5 +75,5 @@
     PRINTF(4)("element is: %s\n", element->Value());
     Factory::fabricate(element);
-    
+
     BaseObject* bo = Factory::fabricate(element);
     if( bo == NULL)
Index: branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 7530)
+++ branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 7532)
@@ -22,22 +22,4 @@
 #include "shell_command.h"
 
-/*#define NUM_PANELS 6;
-
-typedef struct
-{
-	float x;
-	float y;
-	float z;
-} world_vector;
-
-world_vector vertices[NUM_PANELS*4] = {
-	{-50.0, -60.0, 0.0},{50.0, -60.0, 0.0},{50.0, 0.0, 0.0},{-50.0, 0.0, 0.0},
-	{-50.0, -60.0, 60.0},{-50.0, -60.0, 0.0},{-50.0, 0.0, 0.0},{-50.0, 0.0, 60.0},
-	{-50.0, -60.0, 20.0},{-50.0, -60.0, 60.0},{-50.0, 0.0, 60.0},{-50.0, 0.0, 20.0},
-	{50.0, -60.0, 0.0},{50.0, -60.0, 60.0},{50.0, 0.0, 60.0},{50.0, 0.0, 0.0},
-	{50.0, -60.0, 60.0},{50.0, -60.0, 20.0},{50.0, 0.0, 20.0},{50.0, 0.0, 60.0},
-	{-50.0, -60.0, 60.0},{50.0, -60.0, 60.0},{50.0, -60.0, 0.0},{-50.0, -60.0, 0.0}
-};*/
-
 using namespace std;
 
@@ -50,5 +32,5 @@
   if (root != NULL)
     this->loadParams(root);
-  
+
   this->activate();
 }
@@ -59,5 +41,4 @@
   this->deactivate();
 }
-
 
 void VolFogEffect::loadParams(const TiXmlElement* root)
@@ -79,5 +60,4 @@
   PRINTF(0)("Initalize VolFogEffect\n");
 };
-
 
 
@@ -111,41 +91,66 @@
 void VolFogEffect::draw() const
 {
+	// PRINTF(0)("DRAW VolFogEffect\n");
 
-	/*int v;		// store of next vertex ref
-	int ref;
+	glDepthMask(GL_TRUE);
+	glEnable(GL_BLEND);
+	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
+	// glDisable(GL_TEXTURE_2D);
+	// draw the fog panels
+	
+	glBegin(GL_QUADS);
 
-	PRINTF(0)("DRAW VolFogEffect\n");
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f,-10.0f, 10.0f);	// Top Right Of The Quad (Bottom)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f,-10.0f, 10.0f);	// Top Left Of The Quad (Bottom)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f,-10.0f,-10.0f);	// Bottom Left Of The Quad (Bottom)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f,-10.0f,-10.0f);	// Bottom Right Of The Quad (Bottom)
+	
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f, 10.0f, 10.0f);	// Top Right Of The Quad (Front)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f, 10.0f, 10.0f);	// Top Left Of The Quad (Front)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f,-10.0f, 10.0f);	// Bottom Left Of The Quad (Front)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f,-10.0f, 10.0f);	// Bottom Right Of The Quad (Front)
+	
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f,-10.0f,-10.0f);	// Top Right Of The Quad (Back)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f,-10.0f,-10.0f);	// Top Left Of The Quad (Back)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f, 10.0f,-10.0f);	// Bottom Left Of The Quad (Back)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f, 10.0f,-10.0f);	// Bottom Right Of The Quad (Back)
+	
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f, 10.0f, 10.0f);	// Top Right Of The Quad (Left)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f, 10.0f,-10.0f);	// Top Left Of The Quad (Left)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f,-10.0f,-10.0f);	// Bottom Left Of The Quad (Left)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f(-10.0f,-10.0f, 10.0f);	// Bottom Right Of The Quad (Left)
+	
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f, 10.0f,-10.0f);	// Top Right Of The Quad (Right)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - 10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f, 10.0f, 10.0f);	// Top Left Of The Quad (Right)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f,-10.0f, 10.0f);	// Bottom Left Of The Quad (Right)
+	glColor4f(0.6, 0.2, 0.0, (10.0 - (0.0 - -10.0f)) / (10.0 - 0.0));
+	glVertex3f( 10.0f,-10.0f,-10.0f);	// Bottom Right Of The Quad (Right)
 
-	for (ref=0; ref<NUM_PANELS; ref++) {
+	glEnd();
 
-		// disable writes to z buffer (if fog area) 
-		glDepthMask(GL_FALSE);
-	
-		// restore z buffer writes, set blend params & disable texturing 
+	// restore rendering state
 
-		glDepthMask(GL_TRUE);
-		glEnable(GL_BLEND);
-		glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
-		glDisable(GL_TEXTURE_2D);
+	// glEnable(GL_TEXTURE_2D);
+	glDisable(GL_BLEND);
 
-		// draw the fog panel 
-
-		v = ref * 4;
-		glBegin(GL_QUADS);
-		//this->setFogColor(v);
-		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z); v++;
-		//this->setFogColor(v);
-		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z); v++;
-		//this->setFogColor(v);
-		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z); v++;
-		//this->setFogColor(v);
-		glVertex3f(vertices[v].x, vertices[v].y, vertices[v].z);
-		glEnd();
-
-		// restore rendering state
-
-		glEnable(GL_TEXTURE_2D);
-		glDisable(GL_BLEND);
-	}*/	
 }
 