Index: code/trunk/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/HumanController.cc	(revision 7504)
+++ code/trunk/src/orxonox/controllers/HumanController.cc	(revision 7533)
@@ -56,6 +56,4 @@
     SetConsoleCommand("HumanController", "addBots",                &HumanController::addBots       ).addShortcut().defaultValues(1);
     SetConsoleCommand("HumanController", "killBots",               &HumanController::killBots      ).addShortcut().defaultValues(0);
-    SetConsoleCommand("HumanController", "dropItems",              &HumanController::dropItems     ).addShortcut();
-    SetConsoleCommand("HumanController", "useItem",                &HumanController::useItem       ).addShortcut();
     SetConsoleCommand("HumanController", "cycleNavigationFocus",   &HumanController::cycleNavigationFocus).addShortcut();
     SetConsoleCommand("HumanController", "releaseNavigationFocus", &HumanController::releaseNavigationFocus).addShortcut();
@@ -202,10 +200,4 @@
     }
 
-    void HumanController::useItem()
-    {
-        if (HumanController::localController_s && HumanController::localController_s->controllableEntity_)
-            HumanController::localController_s->controllableEntity_->useItem();
-    }
-
     void HumanController::addBots(unsigned int amount)
     {
@@ -218,10 +210,4 @@
         if (HumanController::localController_s && HumanController::localController_s->controllableEntity_ && HumanController::localController_s->controllableEntity_->getGametype())
             HumanController::localController_s->controllableEntity_->getGametype()->killBots(amount);
-    }
-
-    void HumanController::dropItems()
-    {
-        if (HumanController::localController_s && HumanController::localController_s->controllableEntity_)
-            HumanController::localController_s->controllableEntity_->dropItems();
     }
 
Index: code/trunk/src/orxonox/controllers/HumanController.h
===================================================================
--- code/trunk/src/orxonox/controllers/HumanController.h	(revision 7504)
+++ code/trunk/src/orxonox/controllers/HumanController.h	(revision 7533)
@@ -68,6 +68,4 @@
             static void switchCamera();
             static void mouseLook();
-            static void dropItems();
-            static void useItem();
             static void cycleNavigationFocus();
             static void releaseNavigationFocus();
Index: code/trunk/src/orxonox/worldentities/ControllableEntity.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/ControllableEntity.cc	(revision 7504)
+++ code/trunk/src/orxonox/worldentities/ControllableEntity.cc	(revision 7533)
@@ -281,4 +281,5 @@
 
         this->player_ = player;
+        this->formerPlayer_ = player;
         this->playerID_ = player->getObjectID();
         this->bHasLocalController_ = player->isLocalPlayer();
Index: code/trunk/src/orxonox/worldentities/ControllableEntity.h
===================================================================
--- code/trunk/src/orxonox/worldentities/ControllableEntity.h	(revision 7504)
+++ code/trunk/src/orxonox/worldentities/ControllableEntity.h	(revision 7533)
@@ -55,4 +55,10 @@
             inline PlayerInfo* getPlayer() const
                 { return this->player_; }
+            /**
+            @brief Get the player even after the ControllableEntity has stopped being the players ControllableEntity.
+            @return Returns the most recent PlayerInfo.
+            */
+            inline PlayerInfo* getFormerPlayer() const
+                { return this->formerPlayer_; }
 
             inline void setDestroyWhenPlayerLeft(bool bDestroy)
@@ -89,6 +95,4 @@
             virtual void boost() {}
             virtual void greet() {}
-            virtual void useItem() {}
-            virtual void dropItems() {}
             virtual void switchCamera();
             virtual void mouseLook();
@@ -204,4 +208,5 @@
 
             PlayerInfo* player_;
+            PlayerInfo* formerPlayer_;
             unsigned int playerID_;
 
Index: code/trunk/src/orxonox/worldentities/pawns/Pawn.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/pawns/Pawn.cc	(revision 7504)
+++ code/trunk/src/orxonox/worldentities/pawns/Pawn.cc	(revision 7533)
@@ -248,6 +248,4 @@
             this->setDestroyWhenPlayerLeft(false);
 
-            this->dropItems();
-
             if (this->getGametype())
                 this->getGametype()->pawnKilled(this, this->lastHitOriginator_);